<?php
/* Autor...:  */
/* Esquema.: ALM_Marca.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Metodos de acceso a los campos de la tabla ALM_Marca */
abstract class BaseALM_MarcaBN
{
    /* Campos de la tabla */
    private $s_IdMarca;    // IdMarca: ( no definido )
    private $s_DescripcionLocal;    // DescripcionLocal: ( no definido )
    private $s_DescripcionIngles;    // DescripcionIngles: ( no definido )
    private $i_Persona;    // Persona: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )

    /* Establece el valor del campo IdMarca */
    public function setIdMarca( $s_IdMarca )
    {
        $this->s_IdMarca = $s_IdMarca;
    }

    /* Obtiene el valor del campo IdMarca */
    public function getIdMarca()
    {
        return $this->s_IdMarca;
    }

    /* Establece el valor del campo DescripcionLocal */
    public function setDescripcionLocal( $s_DescripcionLocal )
    {
        $this->s_DescripcionLocal = $s_DescripcionLocal;
    }

    /* Obtiene el valor del campo DescripcionLocal */
    public function getDescripcionLocal()
    {
        return $this->s_DescripcionLocal;
    }

    /* Establece el valor del campo DescripcionIngles */
    public function setDescripcionIngles( $s_DescripcionIngles )
    {
        $this->s_DescripcionIngles = $s_DescripcionIngles;
    }

    /* Obtiene el valor del campo DescripcionIngles */
    public function getDescripcionIngles()
    {
        return $this->s_DescripcionIngles;
    }

    /* Establece el valor del campo Persona */
    public function setPersona( $i_Persona )
    {
        $this->i_Persona = $i_Persona;
    }

    /* Obtiene el valor del campo Persona */
    public function getPersona()
    {
        return $this->i_Persona;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdMarca' => $this->getIdMarca(),
            'DescripcionLocal' => $this->getDescripcionLocal(),
            'DescripcionIngles' => $this->getDescripcionIngles(),
            'Persona' => $this->getPersona(),
            'Estado' => $this->getEstado(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_MarcaBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_MarcaRs )
    {
        $o_ALM_MarcaBN = new ALM_MarcaBN();
        $o_ALM_MarcaBN->setIdMarca( $o_ALM_MarcaRs[ "IdMarca" ] );
        $o_ALM_MarcaBN->setDescripcionLocal( $o_ALM_MarcaRs[ "DescripcionLocal" ] );
        $o_ALM_MarcaBN->setDescripcionIngles( $o_ALM_MarcaRs[ "DescripcionIngles" ] );
        $o_ALM_MarcaBN->setPersona( ( integer ) $o_ALM_MarcaRs[ "Persona" ] );
        $o_ALM_MarcaBN->setEstado( $o_ALM_MarcaRs[ "Estado" ] );
        $o_ALM_MarcaBN->setUsuarioModificacion( $o_ALM_MarcaRs[ "UsuarioModificacion" ] );
        $o_ALM_MarcaBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_MarcaRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_MarcaBN->setUsuarioCreacion( $o_ALM_MarcaRs[ "UsuarioCreacion" ] );
        $o_ALM_MarcaBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_MarcaRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        return $o_ALM_MarcaBN;
    }
}
?>